# /summon armor_stand ~ ~1 ~ {CustomName:"\"Wormhole\"",Invulnerable:1b,Invisible:1b,NoGravity:1b,Marker:1b}
# /execute as @e[type=armor_stand,name=Wormhole,distance=..5] at @s rotated as @p[distance=..7] run tp @s ~ ~ ~ ~-90 ~

# Auto-connect to wormholes above
#scoreboard players add @e[type=armor_stand,name=Wormhole] serrRecID 0
#execute as @e[type=armor_stand,name=Wormhole,scores={serrRecID=0}] at @s positioned ~-15 ~ ~-15 run scoreboard players operation @e[type=armor_stand,name=Wormhole,dx=30,dy=100,dz=30,sort=nearest,limit=1] serrRecID = @s serrIntID
#execute as @e[type=armor_stand,name=Wormhole,scores={serrRecID=0}] at @s positioned ~-15 ~ ~-15 run scoreboard players operation @s serrRecID = @e[type=armor_stand,name=Wormhole,dx=30,dy=100,dz=30,sort=nearest,limit=1] serrIntID

# UUID tag system
execute as @e[type=armor_stand,tag=wormholeRecipient] store result score @s serrIntID run data get entity @s UUID[0]

# Wormhole animation
scoreboard players add @e[type=armor_stand,name=Wormhole] wormholeAnim 0
execute at @e[type=armor_stand,name=Wormhole] positioned ~ ~1 ~ run particle minecraft:end_rod ^ ^1 ^ 0 0 0 0 1 force
execute at @e[type=armor_stand,name=Wormhole] positioned ~ ~1 ~ run particle minecraft:end_rod ^ ^-1 ^ 0 0 0 0 1 force
execute as @e[type=armor_stand,name=Wormhole,scores={wormholeAnim=0}] at @s run tp @s ~ ~ ~ ~ ~3
execute as @e[type=armor_stand,name=Wormhole,scores={wormholeAnim=1}] at @s run tp @s ~ ~ ~ ~ ~-3
scoreboard players set @e[type=armor_stand,name=Wormhole,x_rotation=90] wormholeAnim 1
scoreboard players set @e[type=armor_stand,name=Wormhole,x_rotation=-90] wormholeAnim 0

# Going through wormholes
tag @e[type=armor_stand,name=Wormhole] add wormholeRecipient
scoreboard players add @a wormholeTimer 0
scoreboard players add @a[scores={wormholeTimer=..40}] wormholeTimer 1
execute at @e[type=armor_stand,name=Wormhole] positioned ~ ~-1 ~ run tag @a[distance=..1,scores={wormholeTimer=40..}] add isTeleporting
execute as @a[tag=isTeleporting] at @s store result score @s serrRecID run scoreboard players get @e[type=armor_stand,name=Wormhole,sort=nearest,distance=..2,limit=1] serrRecID
execute as @a[tag=isTeleporting,gamemode=!spectator] at @s if entity @e[type=armor_stand,name=Wormhole,tag=serrStartTut,sort=nearest,distance=..6,limit=1] run tag @s add startingTutorial
execute as @a[tag=isTeleporting,gamemode=!spectator] at @s if entity @e[type=armor_stand,name=Wormhole,tag=serrStartTut,sort=nearest,distance=..6,limit=1] run title @s actionbar ""
execute at @a[tag=isTeleporting,gamemode=!spectator] run playsound minecraft:entity.enderman.teleport block @a[distance=..20] ~ ~ ~ 2 1
execute at @a[tag=isTeleporting,gamemode=!spectator] run particle minecraft:instant_effect ~ ~ ~ 1.2 1.2 1.2 0 30
execute as @a[tag=isTeleporting] at @e[type=armor_stand,tag=wormholeRecipient] if score @s serrRecID = @e[type=armor_stand,tag=wormholeRecipient,sort=nearest,distance=..2,limit=1] serrIntID run tp @s ~ ~ ~ ~90 0
execute as @a[tag=isTeleporting] run tp @s
execute at @a[tag=isTeleporting,gamemode=!spectator] run playsound minecraft:entity.enderman.teleport block @a[distance=..20] ~ ~ ~ 2 1
execute at @a[tag=isTeleporting,gamemode=!spectator] run particle minecraft:instant_effect ~ ~ ~ 1.2 1.2 1.2 0 30
scoreboard players set @a[tag=isTeleporting] wormholeTimer 0
tag @a[tag=isTeleporting] remove isTeleporting

# Gilded coast portals

execute at @e[type=armor_stand,name=bluePortal,tag=rot1] run particle minecraft:soul_fire_flame ~ ~7.5 ~ 2.5 4 0 0 3 force
execute at @e[type=armor_stand,name=bluePortal,tag=rot1] run particle minecraft:falling_water ~ ~15 ~ 2.5 0 0 0 4
execute at @e[type=armor_stand,name=bluePortal,tag=rot2] run particle minecraft:soul_fire_flame ~ ~7.5 ~ 0 4 2.5 0 3 force
execute at @e[type=armor_stand,name=bluePortal,tag=rot2] run particle minecraft:falling_water ~ ~15 ~ 0 0 2.5 0 4
execute at @e[type=armor_stand,name=redPortal,tag=rot1] run particle minecraft:flame ~ ~7.5 ~ 2.5 4 0 0 3 force
execute at @e[type=armor_stand,name=redPortal,tag=rot1] run particle minecraft:falling_lava ~ ~15 ~ 2.5 0 0 0 4
execute at @e[type=armor_stand,name=redPortal,tag=rot2] run particle minecraft:flame ~ ~7.5 ~ 0 4 2.5 0 3 force
execute at @e[type=armor_stand,name=redPortal,tag=rot2] run particle minecraft:falling_lava ~ ~15 ~ 0 0 2.5 0 4

tag @a remove isTeleportingGilded
tag @a remove isTeleportingBlue
tag @a remove isTeleportingRed
execute as @e[type=armor_stand,tag=gildedPortal,tag=rot1] at @s[tag=depth1] positioned ~5 ~ ~0.5 run tag @a[dx=-11,dy=6,dz=2,scores={wormholeTimer=40..}] add isTeleportingGilded
execute as @e[type=armor_stand,tag=gildedPortal,tag=rot2] at @s[tag=depth1] positioned ~0.5 ~ ~5 run tag @a[dx=2,dy=6,dz=-11,scores={wormholeTimer=40..}] add isTeleportingGilded
execute as @e[type=armor_stand,tag=gildedPortal,tag=rot1] at @s[tag=depth2] positioned ~5 ~ ~-0.5 run tag @a[dx=-11,dy=6,dz=-2,scores={wormholeTimer=40..}] add isTeleportingGilded
execute as @e[type=armor_stand,tag=gildedPortal,tag=rot2] at @s[tag=depth2] positioned ~-0.5 ~ ~5 run tag @a[dx=-2,dy=6,dz=-11,scores={wormholeTimer=40..}] add isTeleportingGilded
execute at @e[type=armor_stand,name=bluePortal] run tag @a[distance=..7,tag=isTeleportingGilded] add isTeleportingBlue
execute at @e[type=armor_stand,name=redPortal] run tag @a[distance=..7,tag=isTeleportingGilded] add isTeleportingRed

execute at @a[tag=isTeleportingGilded,gamemode=!spectator] run playsound minecraft:entity.enderman.teleport block @a[distance=..20] ~ ~ ~ 2 1
execute at @a[tag=isTeleportingGilded,gamemode=!spectator] run particle instant_effect ~ ~ ~ 1.2 1.2 1.2 0 30
execute as @a[tag=isTeleportingBlue] at @s run tp @s @e[name=redPortal,sort=random,limit=1]
execute as @a[tag=isTeleportingRed] at @s run tp @s @e[name=bluePortal,sort=random,limit=1]
execute as @a[tag=isTeleportingGilded] at @s rotated as @e[tag=gildedPortal,distance=..2,limit=1] run tp @s ^ ^0.5 ^1 ~ ~
execute as @a[tag=isTeleportingGilded] run tp @s
execute at @a[tag=isTeleportingGilded,gamemode=!spectator] run playsound minecraft:entity.enderman.teleport block @a[distance=..20] ~ ~ ~ 2 1
execute at @a[tag=isTeleportingGilded,gamemode=!spectator] run particle instant_effect ~ ~ ~ 1.2 1.2 1.2 0 30
scoreboard players set @a[tag=isTeleportingGilded] wormholeTimer 0