# Drill Shrine
tag @e[tag=isDrillingSounds] remove isDrillingSounds
tag @e[tag=isDrilling] remove isDrilling
execute as @e[type=item,nbt={Item:{tag:{IsSword:1b}}}] at @s[tag=!cannotForge] if block ~ ~-1 ~ minecraft:lodestone run tag @s add isDrilling
execute as @e[type=item,nbt={Item:{tag:{SerrPearl:1b}}}] at @s[tag=!cannotForge] if block ~ ~-1 ~ minecraft:lodestone run tag @s add isDrillingPearl
execute at @e[type=item,tag=isDrillingPearl] store result score @s temp1 run data get entity @s Item.Count
execute at @e[type=item,tag=isDrillingPearl] run loot spawn ~ ~ ~ loot serration:pearl_drilled
execute as @e[type=item,tag=isDrillingPearl] at @s store result score @e[type=item,distance=..2,nbt={Item:{tag:{IsOre:1b}}}] temp2 run data get entity @s Item.Count
execute at @e[type=item,tag=isDrillingPearl] as @e[type=item,distance=..2,nbt={Item:{tag:{IsOre:1b}}}] store result score @s temp1 run data get entity @s Item.Count
execute at @e[type=item,tag=isDrillingPearl] as @e[type=item,distance=..2,nbt={Item:{tag:{IsOre:1b}}}] run scoreboard players operation @s temp1 *= @s temp2
execute at @e[type=item,tag=isDrillingPearl] as @e[type=item,distance=..2,nbt={Item:{tag:{IsOre:1b}}}] store result entity @s Item.Count byte 1 run scoreboard players get @s temp1
execute as @e[type=item,tag=isDrilling] run data merge entity @s {Motion:[0f,0f,0f],PickupDelay:10s}
tag @e[tag=isDrilling] add isDrillingSounds
tag @e[tag=isDrillingPearl] add isDrillingSounds

# Drill Shrine: Pearl
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasPearl:1b}}}] at @s run loot spawn ~ ~ ~ loot serration:pearl
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasPearl:1b}}}] at @s run tag @e[type=item,distance=..3,nbt={Item:{tag:{SerrPearl:1b}}}] add cannotForge
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasPearl:1b}}}] run data modify entity @s Item.tag merge value {HasPearl:0b}

# Drill Shrine: Notches
execute as @e[type=item,tag=isDrilling] store result score @s temp1 run data get entity @s Item.tag.NotchResource0
execute at @e[type=item,tag=isDrilling,scores={temp1=1}] run loot spawn ~ ~ ~ loot serration:aurelium
execute at @e[type=item,tag=isDrilling,scores={temp1=2}] run loot spawn ~ ~ ~ loot serration:ferrox
execute at @e[type=item,tag=isDrilling,scores={temp1=3}] run loot spawn ~ ~ ~ loot serration:ceranite
execute at @e[type=item,tag=isDrilling,scores={temp1=4}] run loot spawn ~ ~ ~ loot serration:fortanium
execute at @e[type=item,tag=isDrilling] run data modify entity @e[type=item,nbt={Age:0s,Item:{tag:{IsOre:1b}}},distance=..2,sort=nearest,limit=1] Item.Count set value 6
execute as @e[type=item,tag=isDrilling] store result score @s temp1 run data get entity @s Item.tag.NotchResource1
execute at @e[type=item,tag=isDrilling,scores={temp1=1}] run loot spawn ~ ~ ~ loot serration:aurelium
execute at @e[type=item,tag=isDrilling,scores={temp1=2}] run loot spawn ~ ~ ~ loot serration:ferrox
execute at @e[type=item,tag=isDrilling,scores={temp1=3}] run loot spawn ~ ~ ~ loot serration:ceranite
execute at @e[type=item,tag=isDrilling,scores={temp1=4}] run loot spawn ~ ~ ~ loot serration:fortanium
execute at @e[type=item,tag=isDrilling] run data modify entity @e[type=item,nbt={Age:0s,Item:{Count:1b,tag:{IsOre:1b}}},distance=..2,sort=nearest,limit=1] Item.Count set value 9
execute as @e[type=item,tag=isDrilling] store result score @s temp1 run data get entity @s Item.tag.NotchResource2
execute at @e[type=item,tag=isDrilling,scores={temp1=1}] run loot spawn ~ ~ ~ loot serration:aurelium
execute at @e[type=item,tag=isDrilling,scores={temp1=2}] run loot spawn ~ ~ ~ loot serration:ferrox
execute at @e[type=item,tag=isDrilling,scores={temp1=3}] run loot spawn ~ ~ ~ loot serration:ceranite
execute at @e[type=item,tag=isDrilling,scores={temp1=4}] run loot spawn ~ ~ ~ loot serration:fortanium
execute at @e[type=item,tag=isDrilling] run data modify entity @e[type=item,nbt={Age:0s,Item:{Count:1b,tag:{IsOre:1b}}},distance=..2,sort=nearest,limit=1] Item.Count set value 12
execute as @e[type=item,tag=isDrilling] run data modify entity @s Item.tag merge value {NotchResource0:0s,NotchResource1:0s,NotchResource2:0s,Notches:0b}

# Drill Shrine: Mods
# Unstackable mods
execute at @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasDisruption:1b}}}] run loot spawn ~ ~ ~ loot serration:mod2
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasDisruption:1b}}}] run data modify entity @s Item.tag merge value {HasDisruption:0b}
execute at @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasSwing:1b}}}] run loot spawn ~ ~ ~ loot serration:mod4
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasSwing:1b}}}] run data modify entity @s Item.tag merge value {HasSwing:0b}
execute at @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasRampart:1b}}}] run loot spawn ~ ~ ~ loot serration:mod6
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasRampart:1b}}}] run data modify entity @s Item.tag merge value {HasRampart:0b}
execute at @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasGouge:1b}}}] run loot spawn ~ ~ ~ loot serration:mod7
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasGouge:1b}}}] run data modify entity @s Item.tag merge value {HasGouge:0b}
execute at @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasStance:1b}}}] run loot spawn ~ ~ ~ loot serration:mod8
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasStance:1b}}}] run data modify entity @s Item.tag merge value {HasStance:0b}
execute at @e[type=item,tag=isDrilling,nbt={Item:{tag:{Has360:1b}}}] run loot spawn ~ ~ ~ loot serration:mod360
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{Has360:1b}}}] run data modify entity @s Item.tag merge value {Has360:0b}

# Stackable mods
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasAlacrity:1b}}}] store result score @s temp1 run data get entity @s Item.tag.AlacrityLevel
execute at @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasAlacrity:1b}}}] run tag @e[type=item,distance=..2] add notNew
execute at @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasAlacrity:1b}}}] run loot spawn ~ ~ ~ loot serration:mod0
execute as @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasAlacrity:1b}}}] at @s store result entity @e[type=item,tag=!notNew,nbt={Age:0s,Item:{Count:1b,tag:{IsMod:1b}}},distance=..2,sort=nearest,limit=1] Item.Count byte 1 run scoreboard players get @s temp1
execute as @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasAlacrity:1b}}}] run data modify entity @s Item.tag merge value {AlacrityLevel:0b,HasAlacrity:0b}
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasSpring:1b}}}] store result score @s temp1 run data get entity @s Item.tag.SpringLevel
execute at @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasSpring:1b}}}] run tag @e[type=item,distance=..2] add notNew
execute at @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasSpring:1b}}}] run loot spawn ~ ~ ~ loot serration:mod1
execute as @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasSpring:1b}}}] at @s store result entity @e[type=item,tag=!notNew,nbt={Age:0s,Item:{Count:1b,tag:{IsMod:1b}}},distance=..2,sort=nearest,limit=1] Item.Count byte 1 run scoreboard players get @s temp1
execute as @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasSpring:1b}}}] run data modify entity @s Item.tag merge value {SpringLevel:0b,HasSpring:0b}
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasCatapult:1b}}}] store result score @s temp1 run data get entity @s Item.tag.CatapultLevel
execute at @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasCatapult:1b}}}] run tag @e[type=item,distance=..2] add notNew
execute at @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasCatapult:1b}}}] run loot spawn ~ ~ ~ loot serration:mod3
execute as @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasCatapult:1b}}}] at @s store result entity @e[type=item,tag=!notNew,nbt={Age:0s,Item:{Count:1b,tag:{IsMod:1b}}},distance=..2,sort=nearest,limit=1] Item.Count byte 1 run scoreboard players get @s temp1
execute as @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasCatapult:1b}}}] run data modify entity @s Item.tag merge value {CatapultLevel:0b,HasCatapult:0b}
execute as @e[type=item,tag=isDrilling,nbt={Item:{tag:{HasLunar:1b}}}] store result score @s temp1 run data get entity @s Item.tag.LunarLevel
execute at @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasLunar:1b}}}] run tag @e[type=item,distance=..2] add notNew
execute at @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasLunar:1b}}}] run loot spawn ~ ~ ~ loot serration:mod5
execute as @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasLunar:1b}}}] at @s store result entity @e[type=item,tag=!notNew,nbt={Age:0s,Item:{Count:1b,tag:{IsMod:1b}}},distance=..2,sort=nearest,limit=1] Item.Count byte 1 run scoreboard players get @s temp1
execute as @e[type=item,tag=isDrilling,scores={temp1=1..},nbt={Item:{tag:{HasLunar:1b}}}] run data modify entity @s Item.tag merge value {LunarLevel:0b,HasLunar:0b}

# Drill Shrine: Particles
execute at @e[type=item,tag=isDrillingSounds] run particle minecraft:crit ~ ~-0.2 ~ 0.4 0.2 0.4 0.3 10 force
execute at @e[type=item,tag=isDrillingSounds] run particle minecraft:explosion ~ ~-0.3 ~ 0 0 0 0 1 force
execute at @e[type=item,tag=isDrillingSounds] run playsound minecraft:item.armor.equip_chain block @a[distance=..20] ~ ~ ~ 1 0.5
execute at @e[type=item,tag=isDrillingSounds] run playsound minecraft:entity.blaze.hurt block @a[distance=..20] ~ ~ ~ 1 0.8

# Drill Shrine: Final adjustments
execute as @e[type=item,tag=isDrilling] store result score @s temp1 run data get entity @s Item.tag.TimesDrilled
execute as @e[type=item,tag=isDrilling] run scoreboard players add @s temp1 1
execute as @e[type=item,tag=isDrilling] store result entity @s Item.tag.TimesDrilled int 1 run scoreboard players get @s temp1
execute as @e[type=item,tag=isDrilling] run tag @s add cannotForge
execute as @e[type=item,tag=isDrilling] run tag @s add resettingLore
execute as @e[type=item,tag=isDrilling] run data modify entity @s Item.tag merge value {SwordOwner:0,ModCapacityUsed:0b}
execute at @e[type=item,tag=isDrilling] as @e[type=item,distance=..3] run data merge entity @s {PickupDelay:3s}
execute at @e[type=item,tag=isDrilling] as @a if score @s serrIntID = @e[type=item,tag=isDrilling,sort=nearest,limit=1] serrIntID run tp @e[type=item,distance=..3] @s
kill @e[type=item,tag=isDrillingPearl]